//
//  NSString+Helper.m
//  CertificationDemo
//
//  Created by 张鹤 on 2018/6/4.
//  Copyright © 2018年 张鹤. All rights reserved.
//

#import "NSString+Helper.h"
#import "NSString+SHA256.h"
#import "UIViewExt.h"

@implementation NSString (Helper)

+ (NSString *)conversationTimeLongToDate{
    NSDate *detailDate = [NSDate date];
    NSDateFormatter*dateFormatter = [[NSDateFormatter alloc]init];
    [dateFormatter setDateFormat:@"yyyy-MM-dd HH:mm:ss"];
    NSString *currentDateStr = [dateFormatter stringFromDate:detailDate];
    
    return currentDateStr;
}
+ (NSString *)getRandomStr
{
    NSString *string = [[NSString alloc]init];
    for (int i = 0; i < 8; i++) {
        int number = arc4random() % 36;
        if (number < 10) {
            int figure = arc4random() % 10;
            NSString *tempString = [NSString stringWithFormat:@"%d", figure];
            string = [string stringByAppendingString:tempString];
        }else {
            int figure = (arc4random() % 26) + 97;
            char character = figure;
            NSString *tempString = [NSString stringWithFormat:@"%c", character];
            string = [string stringByAppendingString:tempString];
        }
    }
    NSLog(@"%@", string);
    return string;
    
}
// 对参数进行签名
+ (NSString *)getSignStringWithDictionary:(NSDictionary *)paramDic{
    
    NSArray *keys = [paramDic allKeys];
    
    NSArray *sortedArray = [keys sortedArrayUsingComparator:^NSComparisonResult(id obj1, id obj2){
        return [obj1 compare:obj2 options:NSNumericSearch];
    }];
    NSString *waitSign;
    for (NSString *keyStr in sortedArray) {
        if (waitSign.length == 0) {
            waitSign = [NSString stringWithFormat:@"%@%@",keyStr,paramDic[keyStr]];
        }else{
            waitSign = [NSString stringWithFormat:@"%@%@%@",waitSign,keyStr,paramDic[keyStr]];
        }
    }
    waitSign = [NSString stringWithFormat:@"%@",waitSign];
    NSString *sign = [self hmac:waitSign withKey:AppSecret];
    return [sign uppercaseString];
    
}


@end
