//
//  PictureSelectActionSheet.m
//  Spark-Client
//
//  Created by 张鹤 on 2018/3/23.
//  Copyright © 2018年 张鹤. All rights reserved.
//

#import "PictureSelectActionSheet.h"
#import "UIAlertController+fitIPadIphone.h"
#import "UIViewExt.h"



@implementation PictureSelectActionSheet
- (id)initWithTitle:(NSString *)title delegate:(id<PictureSheetDelegate>)delegate buttonFTitle:(NSString *)buttonFTitle button2Title:(NSString *)button2Title otherButtonTitles:(NSArray *)otherButtonTitlesArray{
    
    self = [super init];
    if (self) {
        _sheetC = [UIAlertController LK_AlertControllerWithTitle:title message:nil preferredStyle:UIAlertControllerStyleActionSheet];
        UIAlertAction *cameraAction = [UIAlertAction actionWithTitle:buttonFTitle style:UIAlertActionStyleDefault handler:^(UIAlertAction *action) {
            [self didClickOnButtonIndex:0];
        }];
        [_sheetC addAction:cameraAction];
        
        UIAlertAction *libAction = [UIAlertAction actionWithTitle:button2Title style:UIAlertActionStyleDefault handler:^(UIAlertAction *action) {
            [self didClickOnButtonIndex:(NSInteger *)1];

        }];
        [_sheetC addAction:libAction];
        
        UIAlertAction *cancelAction = [UIAlertAction actionWithTitle:@"取消" style:UIAlertActionStyleCancel handler:nil];
        [_sheetC addAction:cancelAction];
        
        
    }
    return self;
}
- (void)showSheetWithCurrentVC:(UIViewController *)vc{
    _currentViewControll = vc;
    [vc presentViewController:_sheetC animated:YES completion:nil];

}
-(void)didClickOnButtonIndex:(NSInteger *)buttonIndex
{
    if (_isChooseTitle) {
        if (buttonIndex == 0) {
            [self.delegate didClickOnButtonIndex:buttonIndex];
        }else if ((int)buttonIndex == 1){
            [self.delegate didClickOnButtonIndex:buttonIndex];

        }
    }else{
        if (0 == buttonIndex) {
            if ([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeCamera])
            {
                [self performSelector:@selector(showCamera) withObject:nil afterDelay:0.3];
            }
        }
        else  if ((int)buttonIndex==1)
        {
            if ([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypePhotoLibrary])
            {
                UIImagePickerController * picker = [[UIImagePickerController alloc] init];
                picker.delegate = self;
                picker.allowsEditing = _allowEdit;
                picker.navigationController.navigationBar.hidden=YES;
                picker.navigationBar.barTintColor = [UIColor whiteColor];
                picker.sourceType = UIImagePickerControllerSourceTypePhotoLibrary;
                [_currentViewControll presentViewController:picker animated:YES completion:nil];
            }
        }
    }

    
}
-(void)showCamera
{
    UIImagePickerController * picker = [[UIImagePickerController alloc] init];
    picker.delegate = self;
    picker.allowsEditing = _allowEdit;
    picker.modalTransitionStyle = UIModalTransitionStyleCoverVertical;
    picker.modalPresentationStyle = UIModalPresentationCurrentContext;
    picker.sourceType =  UIImagePickerControllerSourceTypeCamera;
    picker.showsCameraControls=YES;
    [_currentViewControll presentViewController:picker animated:YES completion:nil];
    
}
-(void)imagePickerController:(UIImagePickerController *)picker didFinishPickingMediaWithInfo:(NSDictionary<NSString *,id> *)info
{
    UIImage *image;
    if (_allowEdit==YES) {
        image=[info objectForKey:UIImagePickerControllerEditedImage];
    }
    else
    {
        image=[info objectForKey:UIImagePickerControllerOriginalImage];
    }
    
    
    CGSize imagesize = image.size;
    //NSLog(@"image.size.height=%f, image.size.width=%f", image.size.height, image.size.width);
    
    float zoom = kScreenWidth / image.size.width;
    //NSLog(@"zoom=%f", zoom);
    imagesize.height = image.size.height * zoom;
    imagesize.width = image.size.width * zoom;
    //对图片大小进行压缩--
    image = [self imageWithImage:image scaledToSize:imagesize];
    
    NSData *pictureData;
    
    if (UIImagePNGRepresentation(image) == nil) {
        pictureData = UIImageJPEGRepresentation(image, 0.0000001);
    } else {
        pictureData = UIImagePNGRepresentation(image);
    }
    self.sendImageBlock(image,pictureData);
    [picker dismissViewControllerAnimated:YES completion:nil];
    
    
}



-(void)imagePickerControllerDidCancel:(UIImagePickerController *)picker{
    [picker dismissViewControllerAnimated:YES completion:nil];
    
    
}

-(UIImage*)imageWithImage:(UIImage*)image scaledToSize:(CGSize)newSize
{
    // Create a graphics image context
    UIGraphicsBeginImageContext(newSize);
    
    // Tell the old image to draw in this new context, with the desired
    // new size
    [image drawInRect:CGRectMake(0,0,newSize.width,newSize.height)];
    
    // Get the new image from the context
    UIImage* newImage = UIGraphicsGetImageFromCurrentImageContext();
    
    // End the context
    UIGraphicsEndImageContext();
    
    // Return the new image.
    return newImage;
}

@end
