//
//  FaceComparisonViewController.m
//  CertificationDemo
//
//  Created by 张鹤 on 2018/6/3.
//  Copyright © 2018年 张鹤. All rights reserved.
//

#import "FaceComparisonViewController.h"
#import "UIViewExt.h"
#import "CustomFieldView.h"
#import "TZImagePickerController.h"
#import "AFNetworking.h"
#import "NSString+Helper.h"
#import "SVProgressHUD.h"

@interface FaceComparisonViewController ()
{
    UIImage *_selectedImage;
}
@property (nonatomic, strong) UIImage *selectedImage;
@property (nonatomic, strong)CustomFieldView *nameTextField;
@property (nonatomic, strong)CustomFieldView *idCardTextField;

@end

@implementation FaceComparisonViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.navigationItem.title = @"人脸比对实名认证";
    self.view.backgroundColor = [UIColor whiteColor];
    [self setUpView];
    
}


- (void)setUpView{
    
    
    _nameTextField = [[CustomFieldView alloc] initWithFrame:CGRectMake(10,  64 + 60, kScreenWidth - 20, 50)];
    [self.view addSubview:_nameTextField];
    _nameTextField.placeholder = @"请输入真实姓名";
    _nameTextField.font = [UIFont systemFontOfSize:14];
    
    _idCardTextField = [[CustomFieldView alloc] initWithFrame:CGRectMake(10, CGRectGetMaxY(_nameTextField.frame) + 10, kScreenWidth - 20, 50)];
    [self.view addSubview:_idCardTextField];
    _idCardTextField.placeholder = @"请输入您的身份证号";
    _idCardTextField.font = [UIFont systemFontOfSize:14];
    
    UIButton *addPhotoButton = [[UIButton alloc] initWithFrame:CGRectMake(10, CGRectGetMaxY(_idCardTextField.frame) + 30, 100, 100)];
    [self.view addSubview:addPhotoButton];
    [addPhotoButton setTitle:@"添加照片" forState:UIControlStateNormal];
    addPhotoButton.layer.borderColor = COLOR(133, 133, 133, 1).CGColor;
    [addPhotoButton addTarget:self action:@selector(addPhotoDidClicked) forControlEvents:UIControlEventTouchUpInside];
    addPhotoButton.tag = 25000;
    addPhotoButton.layer.borderWidth = .5f;
    
    UIButton *saveButton = [[UIButton alloc] initWithFrame:CGRectMake(10, CGRectGetMaxY(addPhotoButton.frame) + 50, kScreenWidth - 20, 50)];
    [self.view addSubview:saveButton];
    [saveButton setBackgroundColor:[UIColor blueColor]];
    [saveButton setTitle:@"开始检测" forState:UIControlStateNormal];
    [saveButton setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
    [saveButton addTarget:self action:@selector(saveButtonDidClicked) forControlEvents:UIControlEventTouchUpInside];
    
    
}
- (void)addPhotoDidClicked{
    TZImagePickerController * vc = [[TZImagePickerController alloc] initWithMaxImagesCount:1 delegate:nil];
    __weak typeof(self) weakSelf = self;
//    UIButton *photoButton = [self.view viewWithTag:25000];
    [vc setDidFinishPickingPhotosHandle:^(NSArray *photos, NSArray *assets, BOOL isSelectOriginalPhoto) {
        UIImage *img = photos.firstObject;
//        weakSelf.selectedImage = img;
        [weakSelf faceDetectWithImage:img];
//        [photoButton setImage:img forState:UIControlStateNormal];
//        weakSelf.selectImages = photos.mutableCopy;
//        weakSelf.selectImageSets = assets.mutableCopy;
//        [weakSelf updatePhotos];
    }];
//    vc.selectedAssets = self.selectImageSets;
    [self presentViewController:vc animated:YES completion:nil];
    
}
- (void) saveButtonDidClicked{
    
    if (_nameTextField.text.length && _idCardTextField.text.length) {
        NSString *urlString = [NSString stringWithFormat:@"%@%@",MAIN_URL,@"/api/router/rest"];
        
        NSData *data;
        for (float i=1.f; i>=0; i -= 0.1) {
            data = UIImageJPEGRepresentation(_selectedImage, i);
            NSUInteger length = [data length]/1024.f;
            if (length < 100) {
                break;
            }
        }
        NSString *encodedImageStr = [data base64EncodedStringWithOptions:NSDataBase64Encoding64CharacterLineLength];
        
        NSDictionary *paramDic = @{@"realname":_nameTextField.text,
                                   @"idcard":_idCardTextField.text,
                                   @"image":encodedImageStr,
                                   @"appKey":AppKey,
                                   @"signMethod":@"HMAC-SHA256",
                                   @"signVersion":@"1",
                                   @"method":@"realid.idcard.detectionFace",
                                   @"format":@"JSON",
                                   @"timestamp":[NSString conversationTimeLongToDate],
                                   @"nonce":[NSString getRandomStr],
                                   @"version":@"1"
                                   };
        NSMutableDictionary *nsParamDic = [[NSMutableDictionary alloc] initWithDictionary:paramDic];
        NSString *sign = [NSString getSignStringWithDictionary:paramDic];
        [nsParamDic setValue:sign forKey:@"sign"];
        AFHTTPSessionManager *sessionManager = [AFHTTPSessionManager manager];
        AFSecurityPolicy *securityPolicy = [AFSecurityPolicy defaultPolicy];
        securityPolicy.validatesDomainName = NO;
        securityPolicy.allowInvalidCertificates = YES;
        sessionManager.securityPolicy = securityPolicy;
        [SVProgressHUD showWithStatus:@"请求中..."];
        [sessionManager POST:urlString parameters:nsParamDic progress:^(NSProgress * _Nonnull uploadProgress) {
        } success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
            NSDictionary *responDic = (NSDictionary *)responseObject;
            if ([responDic[@"code"] intValue]==0) {
                if ([responDic[@"data"][@"valid"] boolValue]) {

                    [SVProgressHUD showSuccessWithStatus:[NSString stringWithFormat:@"%@,相似度为%.2f%%",responDic[@"data"][@"message"],[responDic[@"data"][@"score"] floatValue] * 100]];

                    [SVProgressHUD dismissWithDelay:2];
                }else{
                    [SVProgressHUD showErrorWithStatus:responDic[@"data"][@"message"]];
                    [SVProgressHUD dismissWithDelay:2];
                }
            }else{
                [SVProgressHUD showErrorWithStatus:@"认证失败"];
                [SVProgressHUD dismissWithDelay:2];
            }
            NSLog(@"%@",responDic);
        } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
            NSLog(@"%@",error);
        }];
    }else{
        [SVProgressHUD showErrorWithStatus:@"请填写姓名身份证号码"];
        [SVProgressHUD dismissWithDelay:2];

    }
    
}

#pragma mark - 识别人脸
- (void)faceDetectWithImage:(UIImage *)image {
    // 图像识别能力：可以在CIDetectorAccuracyHigh(较强的处理能力)与CIDetectorAccuracyLow(较弱的处理能力)中选择
    NSDictionary *opts = [NSDictionary dictionaryWithObject:
                          CIDetectorAccuracyHigh forKey:CIDetectorAccuracy];
    // 将图像转换为CIImage
    CIImage *faceImage = [CIImage imageWithCGImage:image.CGImage];
    CIDetector *faceDetector=[CIDetector detectorOfType:CIDetectorTypeFace context:nil options:opts];
    // 识别出人脸数组
    NSArray *features = [faceDetector featuresInImage:faceImage];
    // 得到图片的尺寸
    CGSize inputImageSize = [faceImage extent].size;
    //将image沿y轴对称
    CGAffineTransform transform = CGAffineTransformScale(CGAffineTransformIdentity, 1, -1);
    //将图片上移
    transform = CGAffineTransformTranslate(transform, 0, -inputImageSize.height);
    UIButton *photoButton = [self.view viewWithTag:25000];

    // 取出所有人脸
    for (CIFaceFeature *faceFeature in features){
        //获取人脸的frame
        CGRect faceViewBounds = CGRectApplyAffineTransform(faceFeature.bounds, transform);
        
        // 裁剪人脸
        UIImage *newImage = [UIImage imageWithCGImage:CGImageCreateWithImageInRect([image CGImage], faceViewBounds)];
        
        [photoButton setImage:newImage forState:UIControlStateNormal];
        
        _selectedImage = newImage;
        // 判断是否有左眼位置
        if(faceFeature.hasLeftEyePosition){}
        // 判断是否有右眼位置
        if(faceFeature.hasRightEyePosition){}
        // 判断是否有嘴位置
        if(faceFeature.hasMouthPosition){}
    }
    
}


@end
