//
//  LiveDetectingViewController.m
//  CertificationDemo
//
//  Created by 张鹤 on 2018/6/3.
//  Copyright © 2018年 张鹤. All rights reserved.
//

#import "OnlineLiveDetectViewController.h"
#import "UIViewExt.h"
#import "CustomFieldView.h"
#import "TextFieldTableViewCell.h"
#import "SingleSelectTableViewCell.h"
#import "NSString+Helper.h"
#import "AFNetworking.h"
#import "SVProgressHUD.h"
#
#import <LiveDetectionSDKFrame/LiveDetectionSDKFrame.h>
#import "FaceParameterConfig.h"
#import "PictureSelectActionSheet.h"
#import "ViewController.h"


#define AppKey         [[NSUserDefaults standardUserDefaults] valueForKey:@"appKey"]


@interface OnlineLiveDetectViewController ()<UITableViewDelegate, UITableViewDataSource,UNITIDLivenessResultControllerDelegate,PictureSheetDelegate,UNITIDLivenessResultControllerDelegate>
{
    NSArray  *_selectDataSource;
    UIImage *_selectedImage;
    NSString *_encodedImageStr;
    NSString *_access_token;
}
@property (assign, nonatomic) NSIndexPath *secondIndex;//单选，当前选中的行
@property (nonatomic, strong) UITableView  *liveTableView;

@property (nonatomic, strong) UITextField  *versionField;
@property (nonatomic, strong) UITextField  *tokenField;


@property (nonatomic, strong) NSString *tokenText;
@property (nonatomic, strong) NSString *idCardText;


@property (nonatomic, strong) NSMutableArray * livenessArray;
@property (nonatomic, assign) BOOL order;
@property (nonatomic, assign) NSInteger numberOfLiveness;

@end

@implementation OnlineLiveDetectViewController
- (NSMutableArray *)livenessArray{
    if (_livenessArray == nil) {
        _livenessArray = [[NSMutableArray alloc] init];
    }
    return _livenessArray;
}
- (UITableView *)liveTableView{
    if (_liveTableView == nil) {
        _liveTableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 0, kScreenWidth, kScreenHeight) style:UITableViewStyleGrouped];
        _liveTableView.delegate = self;
        _liveTableView.dataSource = self;
        _liveTableView.separatorStyle = UITableViewCellSeparatorStyleNone;
        [self.view addSubview:_liveTableView];
    }
    return _liveTableView;
}


- (void)viewDidLoad {
    [super viewDidLoad];
    self.view.backgroundColor = [UIColor whiteColor];
    self.navigationItem.title = @"活体检测认证";
    _selectDataSource = @[@"眨眼睛",@"张大嘴",@"向右摇头",@"向左摇头",@"向上抬头",@"向下低头"];
    self.liveTableView.backgroundColor = [UIColor whiteColor];
    
    [self.livenessArray addObject:@0];
    UIView *headView = [[UIView alloc] initWithFrame:CGRectMake(0, 10, kScreenWidth, 100)];
    headView.backgroundColor = [UIColor whiteColor];
    
    
    _tokenField = [[UITextField alloc] initWithFrame:CGRectMake(20, 10, kScreenWidth - 40, 40)];
    _tokenField.placeholder = @"请填写Token";
    _tokenField.font = [UIFont systemFontOfSize:14];
    _tokenField.backgroundColor = [UIColor whiteColor];
    _tokenField.textColor = [UIColor grayColor];
    _tokenField.text = @"ZTZkYjIxYWViNjUyZWUwMTY1NzQwMDJjMDI2NTkzMWExODI0MjkzN2JiMzYyNzdmNjE2YjA4MTRkMWMxZDM3ZmYyMDA2MjllZmI4NTU2NWRiODU5NjdmZjBiYzY=";
    _tokenField.delegate = self;
    
    UILabel *titleLabel = [[UILabel alloc] initWithFrame:CGRectMake(10, CGRectGetMaxY(_tokenField.frame) + 5, kScreenWidth - 20, 30)];
    titleLabel.font = [UIFont systemFontOfSize:12];
    titleLabel.text = @"  - 选择认证模式";
    
    [headView addSubview:_tokenField];
    
    UILabel *line = [[UILabel alloc] initWithFrame:CGRectMake(20, CGRectGetMaxY(_tokenField.frame) - 1, kScreenWidth - 40, 1)];
    [headView addSubview:line];
    line.backgroundColor = [UIColor grayColor];
    
    [headView addSubview:titleLabel];
    
    self.liveTableView.tableHeaderView = headView;
    
}

#pragma mark --- UItableView代理及数据源
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
    return 1;
}
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    
    return _selectDataSource.count;
    
}
- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    return 50;
    
}
- (CGFloat)tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section{
    if (section == 1 || section == 2){
        return 100;
    }else{
        return CGFLOAT_MIN;
    }
}
- (UIView *)tableView:(UITableView *)tableView viewForFooterInSection:(NSInteger)section{
    UIView *buttonView;
    if (section == 0) {
        buttonView = [[UIView alloc] initWithFrame:CGRectMake(0, 0, kScreenWidth, 60)];
        
        UIButton *startButton = [[UIButton alloc] initWithFrame:CGRectMake(10, 0, kScreenWidth - 20, 50)];
        [buttonView addSubview:startButton];
        [startButton setTitle:@"开始检测" forState:UIControlStateNormal];
        [startButton addTarget:self action:@selector(startDetect) forControlEvents:UIControlEventTouchUpInside];
        [startButton setBackgroundColor:[UIColor blueColor]];
        startButton.titleLabel.font = [UIFont systemFontOfSize:14];
        [startButton setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        
    }else{
        buttonView = [[UIView alloc] initWithFrame:CGRectMake(10, 30, kScreenWidth - 20, 0.01)];
        
    }
    
    return buttonView;
}
- (CGFloat)tableView:(UITableView *)tableView heightForFooterInSection:(NSInteger)section{
    if (section == 0) {
        return 60;
    }else{
        return CGFLOAT_MIN;
    }
}
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    static NSString *liveIdentify = @"liveIdentify";
    static NSString *inputIdentify = @"inputIdentify";
    static NSString *selectedIdentify = @"selectedIdentify";
    
    
    SingleSelectTableViewCell *selectedCell = [_liveTableView dequeueReusableCellWithIdentifier:selectedIdentify];
    if (selectedCell == nil) {
        selectedCell = [[SingleSelectTableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:selectedIdentify];
    }
    selectedCell.titleLabel.text = _selectDataSource[indexPath.row];
    if ([_livenessArray containsObject:[NSNumber numberWithInteger:indexPath.row]]) {
        [selectedCell.iconButton setImage:[UIImage imageNamed:@"RadioButton-Selected.png"] forState:UIControlStateNormal];
        
    }else{
        [selectedCell.iconButton setImage:[UIImage imageNamed:@"RadioButton-Unselected.png"] forState:UIControlStateNormal];
        
    }
    
    selectedCell.selectionStyle = UITableViewCellSelectionStyleNone;
    return selectedCell;
}
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    //    if (indexPath.section == 1) {
    if (![_livenessArray containsObject:[NSNumber numberWithInteger:indexPath.row]]) {
        [self.livenessArray addObject:[NSNumber numberWithInteger:indexPath.row]];
    }else{
        [self.livenessArray removeObject:[NSNumber numberWithInteger:indexPath.row]];
    }
    
    
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
    [_liveTableView reloadData];
    
    
}
- (void)tableView:(UITableView *)tableView didDeselectRowAtIndexPath:(NSIndexPath *)indexPath{
    
}
- (void)uploadImage{
    if (_access_token.length == 0) {
        return;
    }
    __weak typeof(self) weakSelf = self;
    PictureSelectActionSheet *pictureActionSheet = [[PictureSelectActionSheet alloc] initWithTitle:@"选择来源" delegate:weakSelf buttonFTitle:@"拍照" button2Title:@"本地相册" otherButtonTitles:@[]];
    pictureActionSheet.allowEdit = YES;
    [pictureActionSheet setSendImageBlock:^(UIImage *image, NSData *imgData) {
        NSLog(@"%@",image);
        NSData *data = UIImageJPEGRepresentation(image, 0.5f);
        [self postImageToServeWithData:data];
    }];
    [pictureActionSheet showSheetWithCurrentVC:self];
}
- (void)startDetect{
    [self.view endEditing:YES];
    
    if ( _tokenField.text.length) {
        if ([LiveFaceSDKManager canWork]) {
            NSString* licensePath = [NSString stringWithFormat:@"%@.%@", FACE_LICENSE_NAME, FACE_LICENSE_SUFFIX];
            [LiveFaceSDKManager setLicenseID:FACE_LICENSE_ID andLocalLicenceFile:licensePath];
        }
        
        
        [[LiveFaceSDKManager sharedInstance] initWithToken:_tokenField.text];
        UnitidLivenessViewController *livenessVC = [[UnitidLivenessViewController alloc] init];
        if (_livenessArray.count) {
            [livenessVC livenesswithList:_livenessArray order:YES numberOfLiveness:_livenessArray.count];
        }else{
            [SVProgressHUD showInfoWithStatus:@"请至少选择一种认证模式"];
            return;
        }
        livenessVC.delegate = self;
        UINavigationController *navi = [[UINavigationController alloc] initWithRootViewController:livenessVC];
        navi.navigationBarHidden = true;
        navi.modalPresentationStyle = UIModalPresentationFullScreen;
        [self presentViewController:navi animated:YES completion:nil];
        
    }else{
        [SVProgressHUD showErrorWithStatus:@"请填写姓名身份证号码"];
        [SVProgressHUD dismissWithDelay:2];
        
    }
    
    
}
#pragma mark - 选择图片
- (void)postImageToServeWithData:(NSData *)img{
    NSString *encodedImageStr = [img base64EncodedStringWithOptions:NSDataBase64Encoding64CharacterLineLength];
    NSString *charactersToEscape = @"?!@#$^&%*+,:;='\"`<>()[]{}/\\| ";
    NSCharacterSet *allowedCharacters = [[NSCharacterSet characterSetWithCharactersInString:charactersToEscape] invertedSet];
    NSString *upSign = [encodedImageStr stringByAddingPercentEncodingWithAllowedCharacters:allowedCharacters];
    
    
    NSString *url = [NSString stringWithFormat:@"https://aip.baidubce.com/rest/2.0/ocr/v1/idcard?access_token=%@",_access_token];
    
    NSDictionary *bodyDic = @{@"image":encodedImageStr};
    
    NSMutableDictionary *mutableDic = [[NSMutableDictionary alloc] initWithDictionary:bodyDic];
    [mutableDic setValue:@"front" forKey:@"id_card_side"];//front：身份证含照片的一面；back：身份证带国徽的一面
    [mutableDic setValue:@"true" forKey:@"detect_direction"];//- true：检测旋转角度并矫正识别；- false：不检测旋转角度，针对摆放情况不可控制的情况建议本参数置为true。
    [mutableDic setValue:@"false" forKey:@"detect_risk"];//是否开启身份证风险类型(身份证复印件、临时身份证、身份证翻拍、修改过的身份证)功能，默认不开启，即：false。可选值:true-开启；false-不开启
    
    NSMutableURLRequest *request = [[AFHTTPRequestSerializer serializer] requestWithMethod:@"POST" URLString:url parameters:nil error:nil];
    [request setValue:@"application/x-www-form-urlencoded" forHTTPHeaderField:@"Content-Type"];
    
    
    
    if (mutableDic != nil) {
        [request setHTTPBody:[[NSString stringWithFormat:@"id_card_side=front&detect_direction=true&detect_risk=false&image=%@",upSign] dataUsingEncoding:NSUTF8StringEncoding]];
    }
    
    
    
    AFURLSessionManager *manager = [[AFURLSessionManager alloc] initWithSessionConfiguration:[NSURLSessionConfiguration defaultSessionConfiguration]];
    
    [[manager dataTaskWithRequest:request completionHandler:^(NSURLResponse * _Nonnull response, id  _Nullable responseObject, NSError * _Nullable error) {
        
        if (!error) {
            NSDictionary *responseDic = (NSDictionary *)responseObject;
            NSLog(@"%@",responseDic);
            if (responseDic[@"error_code"]) {
                
            }else{
                NSDictionary *resultDic = responseDic[@"words_result"];
                for (NSString *key in resultDic.allKeys) {
                    NSLog(@"%@",resultDic[key][@"words"]);
                    if ([key isEqualToString:@"姓名"]) {
                        self.tokenText = resultDic[key][@"words"];
                    }else if ([key isEqualToString:@"公民身份号码"]){
                        self.idCardText = resultDic[key][@"words"];
                    }
                    
                }
                [self.liveTableView reloadData];
            }
        }else{
            
        }
    }] resume] ;
    
    
    
}
#pragma mark - 活体检测代理方法
/**
 活体检测返回结果代理方法
 */
- (void)livenessDetectionControllerDidCancel:(CancelStatus)status{
    
    
}

- (void)livenessDetectionControllerDidGetNetworkResult:(NSDictionary *)response{
    if ([response[@"errorCode"] intValue] == 0) {
        [SVProgressHUD showSuccessWithStatus:@"核验成功"];
    }else{
        [SVProgressHUD showErrorWithStatus:response[@"message"]];
    }
    NSLog(@"%@",response);
}

#pragma mark --- 网络请求

- (void)postLivenessDetectionData{
    
}

#pragma mark - 识别人脸
- (void)faceDetectWithImage:(UIImage *)image {
    // 图像识别能力：可以在CIDetectorAccuracyHigh(较强的处理能力)与CIDetectorAccuracyLow(较弱的处理能力)中选择
    NSDictionary *opts = [NSDictionary dictionaryWithObject:
                          CIDetectorAccuracyHigh forKey:CIDetectorAccuracy];
    // 将图像转换为CIImage
    CIImage *faceImage = [CIImage imageWithCGImage:image.CGImage];
    CIDetector *faceDetector=[CIDetector detectorOfType:CIDetectorTypeFace context:nil options:opts];
    // 识别出人脸数组
    NSArray *features = [faceDetector featuresInImage:faceImage];
    // 得到图片的尺寸
    CGSize inputImageSize = [faceImage extent].size;
    //将image沿y轴对称
    CGAffineTransform transform = CGAffineTransformScale(CGAffineTransformIdentity, 1, -1);
    //将图片上移
    transform = CGAffineTransformTranslate(transform, 0, -inputImageSize.height);
    
    // 取出所有人脸
    for (CIFaceFeature *faceFeature in features){
        //获取人脸的frame
        CGRect faceViewBounds = CGRectApplyAffineTransform(faceFeature.bounds, transform);
        
        // 裁剪人脸
        UIImage *newImage = [UIImage imageWithCGImage:CGImageCreateWithImageInRect([image CGImage], faceViewBounds)];
        
        _selectedImage = newImage;
        [self postLivenessDetectionData];
        
        // 判断是否有左眼位置
        if(faceFeature.hasLeftEyePosition){}
        // 判断是否有右眼位置
        if(faceFeature.hasRightEyePosition){}
        // 判断是否有嘴位置
        if(faceFeature.hasMouthPosition){}
    }
    
}




@end
