//
//  RealNameAndCardViewController.m
//  CertificationDemo
//
//  Created by 张鹤 on 2018/6/3.
//  Copyright © 2018年 张鹤. All rights reserved.
//

#import "RealNameAndCardViewController.h"
#import "UIViewExt.h"
#import "CustomFieldView.h"
#import "AFNetworking.h"
#import "SVProgressHUD.h"
#import "NSString+Helper.h"
#import "NSString+SHA256.h"

@interface RealNameAndCardViewController ()

@property (nonatomic, strong)CustomFieldView *nameTextField;
@property (nonatomic, strong)CustomFieldView *idCardTextField;
@end

@implementation RealNameAndCardViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.navigationItem.title = @"实名认证";
    self.view.backgroundColor = [UIColor whiteColor];
    [self setUpView];

}


- (void)setUpView{
    
    _nameTextField = [[CustomFieldView alloc] initWithFrame:CGRectMake(10, 64 + 60, kScreenWidth - 20, 50)];
    [self.view addSubview:_nameTextField];
    _nameTextField.placeholder = @"请输入真实姓名";
    _nameTextField.font = [UIFont systemFontOfSize:14];

    _idCardTextField = [[CustomFieldView alloc] initWithFrame:CGRectMake(10, CGRectGetMaxY(_nameTextField.frame) + 10, kScreenWidth - 20, 50)];
    [self.view addSubview:_idCardTextField];
    _idCardTextField.placeholder = @"请输入您的身份证号";
    _idCardTextField.font = [UIFont systemFontOfSize:14];

    UIButton *saveButton = [[UIButton alloc] initWithFrame:CGRectMake(10, CGRectGetMaxY(_idCardTextField.frame) + 50, kScreenWidth - 20, 50)];
    [self.view addSubview:saveButton];
    [saveButton setBackgroundColor:[UIColor blueColor]];
    [saveButton setTitle:@"开始认证" forState:UIControlStateNormal];
    [saveButton setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
    [saveButton addTarget:self action:@selector(saveButtonDidClicked) forControlEvents:UIControlEventTouchUpInside];
    
    
}

- (void) saveButtonDidClicked{

    if (_nameTextField.text.length && _idCardTextField.text.length) {
        NSString *urlString = [NSString stringWithFormat:@"%@%@",MAIN_URL,@"/api/router/rest"];
        
        NSDictionary *paramDic = @{@"realname":_nameTextField.text,
                                   @"idcard":_idCardTextField.text,
                                   @"appKey":AppKey,
                                   @"signMethod":@"HMAC-SHA256",
                                   @"signVersion":@"1",
                                   @"method":@"realid.idcard.verify",
                                   @"format":@"JSON",
                                   @"timestamp":[NSString conversationTimeLongToDate],
                                   @"nonce":[NSString getRandomStr],
                                   @"version":@"1"
                                   };
        NSMutableDictionary *nsParamDic = [[NSMutableDictionary alloc] initWithDictionary:paramDic];
        NSString *sign = [NSString getSignStringWithDictionary:paramDic];
        [nsParamDic setValue:sign forKey:@"sign"];
        AFHTTPSessionManager *sessionManager = [AFHTTPSessionManager manager];
        AFSecurityPolicy *securityPolicy = [AFSecurityPolicy defaultPolicy];
        securityPolicy.validatesDomainName = NO;
        securityPolicy.allowInvalidCertificates = YES;
        sessionManager.securityPolicy = securityPolicy;
        [SVProgressHUD showWithStatus:@"请求中..."];
        [sessionManager POST:urlString parameters:nsParamDic progress:^(NSProgress * _Nonnull uploadProgress) {
        } success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
            NSDictionary *responDic = (NSDictionary *)responseObject;
            if ([responDic[@"code"] intValue]==0) {
                if (responDic[@"data"][@"valid"]) {
                    [SVProgressHUD showSuccessWithStatus:@"一致"];
                    [SVProgressHUD dismissWithDelay:2];

                }else{
                    [SVProgressHUD showErrorWithStatus:responDic[@"data"][@"message"]];
                    [SVProgressHUD dismissWithDelay:2];

                }
            }else{
                [SVProgressHUD showErrorWithStatus:@"认证失败"];
                [SVProgressHUD dismissWithDelay:2];

            }
        } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
            NSLog(@"%@",error);
        }];
    }else{
        [SVProgressHUD showErrorWithStatus:@"请填写姓名身份证号码"];
        [SVProgressHUD dismissWithDelay:2];

    }

    
}
@end
