//
//  SetUpInfoViewController.m
//  CertificationDemo
//
//  Created by 张鹤 on 2018/6/3.
//  Copyright © 2018年 张鹤. All rights reserved.
//

#import "SetUpInfoViewController.h"
#import "UIViewExt.h"
#import "CustomFieldView.h"
#import "SVProgressHUD.h"

@interface SetUpInfoViewController ()

@property (nonatomic, strong)CustomFieldView *appKeyTextField;
@property (nonatomic, strong)CustomFieldView *appSecretTextField;
@end

@implementation SetUpInfoViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.navigationItem.title = @"设置";
    self.view.backgroundColor = [UIColor whiteColor];
    [self setUpView];
    
    
}

- (void)setUpView{
    
    UILabel *infoLabel = [[UILabel alloc] initWithFrame:CGRectMake(10, 64 + 40, kScreenWidth - 20, 50)];
    [self.view addSubview:infoLabel];
    infoLabel.font = [UIFont systemFontOfSize:14];
    infoLabel.textColor = COLOR(133, 133, 133, 1);
    infoLabel.text = @"app在使用前请设置appkey及AppSecret,否则APP将无法正常使用";
    infoLabel.numberOfLines = 0;
    
    _appKeyTextField = [[CustomFieldView alloc] initWithFrame:CGRectMake(10, CGRectGetMaxY(infoLabel.frame) + 10, kScreenWidth - 20, 50)];
    [self.view addSubview:_appKeyTextField];
    _appKeyTextField.placeholder = @"请输入APP Key";
    _appKeyTextField.font = [UIFont systemFontOfSize:14];
    _appKeyTextField.text = @"36NPI9bHYZbkX9MR";
    
    _appSecretTextField = [[CustomFieldView alloc] initWithFrame:CGRectMake(10, CGRectGetMaxY(_appKeyTextField.frame) + 10, kScreenWidth - 20, 50)];
    [self.view addSubview:_appSecretTextField];
    _appSecretTextField.placeholder = @"请输入APP Secret";
    _appSecretTextField.font = [UIFont systemFontOfSize:14];
    _appSecretTextField.text = @"25fd92b4316244889d49d137ea885820";

    UIButton *saveButton = [[UIButton alloc] initWithFrame:CGRectMake(10, CGRectGetMaxY(_appSecretTextField.frame) + 100, kScreenWidth - 20, 50)];
    [self.view addSubview:saveButton];
    [saveButton setBackgroundColor:[UIColor blueColor]];
    [saveButton setTitle:@"设置" forState:UIControlStateNormal];
    [saveButton setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
    [saveButton addTarget:self action:@selector(saveButtonDidClicked) forControlEvents:UIControlEventTouchUpInside];
    if (AppKey) {
        _appKeyTextField.text = AppKey;
    }
    if (AppSecret) {
        _appSecretTextField.text = AppSecret;
    }
    
}
- (void) saveButtonDidClicked{
    if (_appKeyTextField.text.length && _appSecretTextField.text.length) {
        
        [[NSUserDefaults standardUserDefaults] setValue:_appKeyTextField.text forKey:@"appKey"];
        [[NSUserDefaults standardUserDefaults] setValue:_appSecretTextField.text forKey:@"appSecret"];
        
        [SVProgressHUD showSuccessWithStatus:@"保存成功"];
        [SVProgressHUD dismissWithDelay:2];

//        [[NSUserDefaults standardUserDefaults] valueForKey:@"appKey"];
//        [[NSUserDefaults standardUserDefaults] valueForKey:@"appSecret"];

    }else{
        [SVProgressHUD showErrorWithStatus:@"请填写App信息"];
        [SVProgressHUD dismissWithDelay:2];
    }
    
}

@end
