//
//  ViewController.m
//  CertificationDemo
//
//  Created by 张鹤 on 2018/6/3.
//  Copyright © 2018年 张鹤. All rights reserved.
//

#import "ViewController.h"
#import "CertificateTableViewCell.h"
#import "SetUpInfoViewController.h"
#import "RealNameAndCardViewController.h"
#import "PhoneNumberCerViewController.h"
#import "FaceComparisonViewController.h"
#import "LiveDetectingViewController.h"
#import "AboutViewController.h"
#import "AnotherLiveDetectingViewController.h"
#import "FaceDetectingViewController.h"
#import "OnlineLiveDetectViewController.h"


//cn.unitid.spark.demo.detection
@interface ViewController ()<UITableViewDelegate, UITableViewDataSource>
{
    NSArray *_dataSource;
}
@property (nonatomic, strong) UITableView *myTableView;
@end

@implementation ViewController
- (UITableView *)myTableView{
    
    if (_myTableView == nil) {
        _myTableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height) style:UITableViewStyleGrouped];
        _myTableView.delegate = self;
        _myTableView.dataSource = self;
        [self.view addSubview:_myTableView];
    }
    return _myTableView;
}
- (void)viewDidLoad {
    [super viewDidLoad];
    self.navigationItem.title = @"实名认证演示";
    self.view.backgroundColor = [UIColor whiteColor];
    _dataSource = @[@"设置appkey和appSecret",@"姓名、身份证号实名认证",@"姓名身份证号、手机号实名认证",@"人脸比对实名认证",@"活体检测实名认证（已废弃）",@"在线活体SDK",@"人脸裁剪算法"];
    self.myTableView.backgroundColor = [UIColor whiteColor];
    [self setupNavigationLeftbarButton];

}
- (void)setupNavigationLeftbarButton{
    UIButton *aboutBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    aboutBtn.frame = CGRectMake(0, 0, 44, 44);
    [aboutBtn.imageView setContentMode:UIViewContentModeScaleAspectFit];
    [aboutBtn setTitle:@"关于" forState:UIControlStateNormal];
    [aboutBtn setImageEdgeInsets:UIEdgeInsetsMake(10, 0, 10, 10)];
    [aboutBtn addTarget:self action:@selector(gotoAboutVC) forControlEvents:UIControlEventTouchUpInside];
    [aboutBtn setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
    aboutBtn.titleLabel.font = [UIFont systemFontOfSize:14];
    
    /* leftBarButton设置 */
    UIBarButtonItem *left = [[UIBarButtonItem alloc] initWithCustomView:aboutBtn];
    UIBarButtonItem *negativeSpacer = [[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemFixedSpace target:nil action:nil];
    [negativeSpacer setWidth:-10];
    self.navigationItem.rightBarButtonItems = @[negativeSpacer,left];
    
}
- (void)gotoAboutVC{

    AboutViewController *aboutVC = [[AboutViewController alloc] init];
    [self.navigationController pushViewController:aboutVC animated:YES];
}
#pragma mark --- UITableViewDelegate 及DataSource
- (NSInteger) tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return _dataSource.count;
}
- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    return 60;
}
- (CGFloat)tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section{
    return 0.01;
}
- (CGFloat)tableView:(UITableView *)tableView heightForFooterInSection:(NSInteger)section{
    return 0.01;
}
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    static NSString *tableCellIdentify = @"tableCellIdentify";
    CertificateTableViewCell *demoCell = [_myTableView dequeueReusableCellWithIdentifier:tableCellIdentify];
    if (demoCell == nil) {
        demoCell = [[CertificateTableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:tableCellIdentify];
        
    }
    [demoCell.typeButton setTitle:_dataSource[indexPath.row] forState:UIControlStateNormal];
    demoCell.selectionStyle = UITableViewCellSelectionStyleNone;
    return demoCell;
}
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    if (indexPath.row == 0) {
        SetUpInfoViewController *setupVC = [[SetUpInfoViewController alloc] init];
        [self.navigationController pushViewController:setupVC animated:YES];
        
    }else if (indexPath.row == 1){
        RealNameAndCardViewController *realNameVC = [[RealNameAndCardViewController alloc] init];
        [self.navigationController pushViewController:realNameVC animated:YES];
        
    }else if (indexPath.row == 2){
        PhoneNumberCerViewController *phoneNumberVC = [[PhoneNumberCerViewController alloc] init];
        [self.navigationController pushViewController:phoneNumberVC animated:YES];
        
    }else if (indexPath.row == 3){
        FaceComparisonViewController *faceComparisonVC = [[FaceComparisonViewController alloc] init];
        [self.navigationController pushViewController:faceComparisonVC animated:YES];
        
    }else if (indexPath.row == 4){
        AnotherLiveDetectingViewController *liveVC = [[AnotherLiveDetectingViewController alloc] init];
        [self.navigationController pushViewController:liveVC animated:YES];
//        SyanLiveDetectingViewController *liveVC = [[SyanLiveDetectingViewController alloc] init];
//        [self.navigationController pushViewController:liveVC animated:YES];
    }else if (indexPath.row == 5){
        OnlineLiveDetectViewController *liveVC = [[OnlineLiveDetectViewController alloc] init];
        [self.navigationController pushViewController:liveVC animated:YES];
    }else if (indexPath.row == 6){
        FaceDetectingViewController *liveVC = [[FaceDetectingViewController alloc] init];
        [self.navigationController pushViewController:liveVC animated:YES];
    }
}

@end
